{ Copyright (C) 2012 H Page-Clark

  This source is free software; you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free
  Software Foundation; either version 2 of the License, or (at your option)
  any later version.

  This code is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
  details.

  A copy of the GNU General Public License is available on the World Wide Web
  at <http://www.gnu.org/copyleft/gpl.html>. You can also obtain it by writing
  to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
  MA 02111-1307, USA. }

unit label_form;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls;

const limit = 3;
      cWidth = 100;
      cHeight = 35;

type

  TLabelGrid = array[0..limit, 0..limit] of TLabel;

  { TpropertiesForm }

  TpropertiesForm = class(TForm)
    cgFontStyle: TCheckGroup;
    rgAlignment: TRadioGroup;
    rgLayout: TRadioGroup;
    procedure cgFontStyleItemClick(Sender: TObject; Index: integer);
    procedure FormCreate(Sender: TObject);
    procedure rgAlignmentClick(Sender: TObject);
    procedure rgLayoutClick(Sender: TObject);
  private
    labelGrid: TLabelGrid;
    procedure SetupLabelGrid;
    function CreateLabel(aRow, aCol: integer): TLabel;
  public
    { public declarations }
  end;

var
  propertiesForm: TpropertiesForm;

implementation

{$R *.lfm}

{ TpropertiesForm }

procedure TpropertiesForm.FormCreate(Sender: TObject);
begin
  SetupLabelGrid;
end;

procedure TpropertiesForm.cgFontStyleItemClick(Sender: TObject; Index: integer);
var c, r: integer;
    fs: TFontStyle;
begin
  fs := TFontStyle(Index);
  for c := 0 to limit do
   for r := 0 to limit do
     if cgFontStyle.Checked[Index]
      then labelGrid[c, r].Font.Style := labelGrid[c, r].Font.Style + [fs]
      else labelGrid[c, r].Font.Style := labelGrid[c, r].Font.Style - [fs];
end;

procedure TpropertiesForm.rgAlignmentClick(Sender: TObject);
var rg: TRadioGroup;
    c, r, idx: integer;
    alygnment: TAlignment;
begin
  rg := TRadioGroup(Sender);
  idx := rg.ItemIndex;
  alygnment := TAlignment(idx);
  for c := 0 to limit do
   for r := 0 to limit do
    labelGrid[c, r].Alignment:= alygnment;
end;

procedure TpropertiesForm.rgLayoutClick(Sender: TObject);
var rg: TRadioGroup;
    c, r, idx: integer;
    layowt: TTextLayout;
begin
  rg := TRadioGroup(Sender);
  idx := rg.ItemIndex;
  layowt := TTextLayout(idx);
  for c := 0 to limit do
   for r := 0 to limit do
    labelGrid[c, r].Layout:= layowt;
end;

procedure TpropertiesForm.SetupLabelGrid;
var c, r : Integer;
begin
  for c := 0 to limit do
   for r := 0 to limit do
    begin
     labelGrid[c, r] := CreateLabel(c, r);
    end;
end;

function TpropertiesForm.CreateLabel(aRow, aCol: integer): TLabel;
var sum: integer;
begin
  result := TLabel.Create(Self);
  result.Parent := Self;
  result.Caption:= Format('col:%d, row:%d', [aCol, aRow]);
  result.AutoSize:= False;
  result.SetBounds(aCol*cWidth, aRow*cHeight, cWidth, cHeight);
  sum := aCol + aRow;
  if (sum = 1) then sum := 4;
  result.Color:= clInfoBk + sum;
end;

end.

