{ Copyright (C) 2012 H Page-Clark

  This source is free software; you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free
  Software Foundation; either version 2 of the License, or (at your option)
  any later version.

  This code is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
  details.

  A copy of the GNU General Public License is available on the World Wide Web
  at <http://www.gnu.org/copyleft/gpl.html>. You can also obtain it by writing
  to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
  MA 02111-1307, USA. }

unit main_factorial;

{$mode objfpc}{$H+}

interface

uses
  SysUtils, Forms, Dialogs, StdCtrls, Spin;

type

  { TForm1 }

  TForm1 = class(TForm)
    BListFactorials: TButton;
    BFactorialException: TButton;
    EParameter: TSpinEdit;
    MDisplay: TMemo;
    procedure BFactorialExceptionClick(Sender: TObject);
    procedure BListFactorialsClick(Sender: TObject);
  private
    function Factorial64(aByte: byte): int64;
    function FactorialExc(aByte: byte): int64;
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.BListFactorialsClick(Sender: TObject);
var i: integer;
begin
  MDisplay.Lines.Clear;
  for i := 1 to EParameter.Value do
   MDisplay.Lines.Add(Format('%d! is %s',[i, FormatFloat(',#',Factorial64(i))]));
end;

procedure TForm1.BFactorialExceptionClick(Sender: TObject);
var i: integer;
begin
 MDisplay.Lines.Clear;
  for i := 1 to EParameter.Value do
   MDisplay.Lines.Add(Format('%d! is %s',[i, FormatFloat(',#',FactorialExc(i))]));
end;

function TForm1.Factorial64(aByte: byte): int64;
begin
  case aByte of
   0, 1: Result:= 1;
   else Result:= aByte * Factorial64(aByte - 1);
  end;
end;

function TForm1.FactorialExc(aByte: byte): int64;
begin
  Result:= -1;
  case aByte of
   0, 1: Result:= 1;
   else
    try
     Result:= aByte * FactorialExc(aByte - 1);
    except on e:EIntOverflow do
     MessageDlg('Problem',
                Format('"%s"%sA parameter value of %d caused the above exception in the'+
                    ' FactorialExc function', [e.Message, LineEnding, aByte]),
                mtWarning,
                [mbClose], 0);
    end;
  end;
end;

end.

