unit testcaseParseWords;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, fpcunit, testutils, testregistry, parseWords;

type
  TTestRec = record
    testStr: string;
    slWords: TStringList;
  end;

  TTestParseWords= class(TTestCase)
  protected
    procedure SetUp; override;
    procedure TearDown; override;
  published
    procedure TestHookUp;
  private
    Ftr: TTestRec;
  end;

implementation

procedure TTestParseWords.TestHookUp;
begin
  AssertNull('Empty string parameter', ParseToWords('', []));
  AssertEquals('All separator string', 0, ParseToWords('-+.,/;#~[]{}',[]).Count);
  AssertEquals('Separators beginning and end', 5, ParseToWords('_This_parses_to_five_words_',['_']).Count);
  AssertEquals('Initial adjacent separators', 3, ParseToWords(',,,,Initial adjacent separators',[',',' ']).Count);
end;

procedure TTestParseWords.SetUp;
begin
  Ftr.slWords.Create;
  Ftr.testStr:= '';
end;

procedure TTestParseWords.TearDown;
begin
  Ftr.slWords.Free;
end;

initialization

  RegisterTest(TTestParseWords);
end.

