{ Copyright (C) 2012 H Page-Clark

  This source is free software; you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free
  Software Foundation; either version 2 of the License, or (at your option)
  any later version.

  This code is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
  details.

  A copy of the GNU General Public License is available on the World Wide Web
  at <http://www.gnu.org/copyleft/gpl.html>. You can also obtain it by writing
  to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
  MA 02111-1307, USA. }

unit unit_main;

{$mode objfpc}{$H+}
{$ASSERTIONS ON}

interface

uses
  SysUtils, Forms, Dialogs, StdCtrls;

type
  TStrArray = array of string;

  TfrmTestAssert = class(TForm)
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  public
    Farray: TStrArray;
    procedure DeleteStringAt(var anArray: TStrArray; anIndex: integer);
    procedure ShowArray;
  end;

var frmTestAssert: TfrmTestAssert;

implementation

procedure TfrmTestAssert.Button1Click(Sender: TObject);
begin
  SetLength(Farray, 7);
  Farray[0]:= 'This '; Farray[1]:= 'string '; Farray[2]:= 'does ';
  Farray[3]:= 'not ' ; Farray[4]:= 'have '  ; Farray[5]:= 'six ';
  Farray[6]:= 'words';
  ShowArray;
  ShowMessage('Calling DeleteStringAt(Farray, 3)');
  DeleteStringAt(Farray, 3);
  ShowArray;
  DeleteStringAt(Farray, 7); // comment this line to untest assertion
end;

procedure TfrmTestAssert.DeleteStringAt(var anArray: TStrArray; anIndex: integer);
begin
  Assert(Assigned(anArray), 'nonexistent array');
  Assert((anIndex >= Low(anArray)) and (anIndex <= High(anArray)),
   Format('index value %d out of range in DeleteStringAt procedure',[anIndex]));
  Move(anArray[anIndex+1], anArray[anIndex],
       (High(anArray)-anIndex)*SizeOf(string));
  SetLength(anArray, Length(anArray)-1);
end;

procedure TfrmTestAssert.ShowArray;
var s: string;
    z: string = '';
begin
 for s in Farray do
  AppendStr(z, s);
 ShowMessage(z);
end;

{$R *.lfm}

end.

