{ Copyright (C) 2012 H Page-Clark

  This source is free software; you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free
  Software Foundation; either version 2 of the License, or (at your option)
  any later version.

  This code is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
  details.

  A copy of the GNU General Public License is available on the World Wide Web
  at <http://www.gnu.org/copyleft/gpl.html>. You can also obtain it by writing
  to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
  MA 02111-1307, USA. }

unit drawingdisplay;

{$mode objfpc}{$H+}

interface

uses
  Forms, ExtCtrls, drawing;

const extent = 50;

type

  { TForm1 }

  TForm1 = class(TForm)
    rgShape: TRadioGroup;
    procedure FormCreate(Sender: TObject);
    procedure rgShapeClick(Sender: TObject);
  private
    FDrawing: TDrawing;
    procedure CreateANewDrawing;
  end;

var
  Form1: TForm1;

implementation

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  CreateANewDrawing;
end;

procedure TForm1.rgShapeClick(Sender: TObject);
begin
  CreateANewDrawing;
end;

procedure TForm1.CreateANewDrawing;
begin
  if rgShape.ItemIndex < 0 then Exit;
  FDrawing.Free;
  case rgShape.ItemIndex of
   0: begin FDrawing := TSquare.Create(Self, extent); FDrawing.Left:= 10; end;
   1: begin FDrawing := TCircle.Create(Self, extent); FDrawing.Left:= 60; end;
  end;
  FDrawing.Top := 10;
  FDrawing.Parent := Self;
end;

{$R *.lfm}

end.

